// $ANTLR 2.7.6 (2005-12-22): "cpp.g" -> "CppParser.java"$

// This file is part of the program FRYSK.
//
// Copyright 2005, Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    /* import frysk.value.*; */
    /* import java.util.*; */
    import lib.dw.BaseTypes;
    import inua.eio.ByteOrder;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
/* import antlr.TokenStreamIOException; */
/* import antlr.ANTLRException; */
/* import antlr.LLkParser; */
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
/* import antlr.MismatchedTokenException; */
/* import antlr.SemanticException; */
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
/* import java.util.Hashtable; */
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class CppParser extends antlr.LLkParser       implements CppParserTokenTypes
 {

/** 
  *	A member variable to keep track of TAB completions requests.
  *	If this is true the normal course of action is to simply
  *	bail out by throwing an exception
  */
    private boolean bTabPressed;
    private int assign_stmt_RHS_found;
    private String sInputExpression;

    protected CppParser(TokenStream lexer, String sInput)
    {
        this(lexer);
        bTabPressed = false;
        sInputExpression = sInput;
    }

protected CppParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public CppParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected CppParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public CppParser(TokenStream lexer) {
  this(lexer,2);
}

public CppParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

/** 
  * These tokens are never returned by the Lexer. These are imaginary
  * tokens used as root nodes in the generated Abstract Syntax Tree.
  */
	public final void imaginaryTokenDefinitions() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST imaginaryTokenDefinitions_AST = null;
		
		AST tmp1_AST = null;
		tmp1_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp1_AST);
		match(ARG_LIST);
		AST tmp2_AST = null;
		tmp2_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp2_AST);
		match(ARRAY_REF);
		AST tmp3_AST = null;
		tmp3_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp3_AST);
		match(CAST);
		AST tmp4_AST = null;
		tmp4_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp4_AST);
		match(COND_EXPR);
		AST tmp5_AST = null;
		tmp5_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp5_AST);
		match(EXPR_LIST);
		AST tmp6_AST = null;
		tmp6_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp6_AST);
		match(FUNC_CALL);
		imaginaryTokenDefinitions_AST = (AST)currentAST.root;
		returnAST = imaginaryTokenDefinitions_AST;
	}
	
/** 
  * The start rule simply expects an expression list following by
  * the end of text symbol (ETX \3).
  *
  * The TabException propagates all the way up, to the start rule,
  * which then propagates it up to the calling program.
  */
	public final void start() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST start_AST = null;
		
		expressionList();
		astFactory.addASTChild(currentAST, returnAST);
		AST tmp7_AST = null;
		tmp7_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp7_AST);
		match(ETX);
		start_AST = (AST)currentAST.root;
		returnAST = start_AST;
	}
	
/**
  *  This rule looks for comma separated expressions.
  */
	public final void expressionList() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expressionList_AST = null;
		
		expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop5:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop5;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			expressionList_AST = (AST)currentAST.root;
			expressionList_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EXPR_LIST,"Expr list")).add(expressionList_AST));
			currentAST.root = expressionList_AST;
			currentAST.child = expressionList_AST!=null &&expressionList_AST.getFirstChild()!=null ?
				expressionList_AST.getFirstChild() : expressionList_AST;
			currentAST.advanceChildToEnd();
		}
		expressionList_AST = (AST)currentAST.root;
		returnAST = expressionList_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_AST = null;
		AST assign_expr1_AST = null;
		
		assignment_expression();
		assign_expr1_AST = (AST)returnAST;
		if ( inputState.guessing==0 ) {
			expression_AST = (AST)currentAST.root;
			
			/** 
			* The following syntax is used for generation of ASTs. 
			* The # before a symbol refers to the AST for that symbol. 
			* ## refers to the AST returned by this rule (expression)
			*/
			
			expression_AST = assign_expr1_AST;
			
			currentAST.root = expression_AST;
			currentAST.child = expression_AST!=null &&expression_AST.getFirstChild()!=null ?
				expression_AST.getFirstChild() : expression_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = expression_AST;
	}
	
/**
  *  Assignment expressions of the form "expr1 = expr2 = expr3".
  *  Notice that the operator can by any assignment operator.
  */
	public final void assignment_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST assignment_expression_AST = null;
		AST c_AST = null;
		AST a_AST = null;
		AST r_AST = null;
		
		{
		conditional_expression();
		c_AST = (AST)returnAST;
		{
		switch ( LA(1)) {
		case ASSIGNEQUAL:
		case TIMESEQUAL:
		case DIVIDEEQUAL:
		case MINUSEQUAL:
		case PLUSEQUAL:
		case MODEQUAL:
		case SHIFTLEFTEQUAL:
		case SHIFTRIGHTEQUAL:
		case BITWISEANDEQUAL:
		case BITWISEXOREQUAL:
		case BITWISEOREQUAL:
		{
			assign_op();
			a_AST = (AST)returnAST;
			remainder_expression();
			r_AST = (AST)returnAST;
			break;
		}
		case ETX:
		case COMMA:
		case RPAREN:
		case COLON:
		case RSQUARE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		if ( inputState.guessing==0 ) {
			assignment_expression_AST = (AST)currentAST.root;
			
			if (a_AST != null)
			assignment_expression_AST = (AST)astFactory.make( (new ASTArray(3)).add(a_AST).add(c_AST).add(r_AST));
			else
			assignment_expression_AST = c_AST;
			
			currentAST.root = assignment_expression_AST;
			currentAST.child = assignment_expression_AST!=null &&assignment_expression_AST.getFirstChild()!=null ?
				assignment_expression_AST.getFirstChild() : assignment_expression_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = assignment_expression_AST;
	}
	
/**
  *  Various types of assignment operators like +=, *=, /= etc.
  */
	public final void assign_op() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST assign_op_AST = null;
		
		switch ( LA(1)) {
		case ASSIGNEQUAL:
		{
			AST tmp9_AST = null;
			tmp9_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp9_AST);
			match(ASSIGNEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case TIMESEQUAL:
		{
			AST tmp10_AST = null;
			tmp10_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp10_AST);
			match(TIMESEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case DIVIDEEQUAL:
		{
			AST tmp11_AST = null;
			tmp11_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp11_AST);
			match(DIVIDEEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case MINUSEQUAL:
		{
			AST tmp12_AST = null;
			tmp12_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp12_AST);
			match(MINUSEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case PLUSEQUAL:
		{
			AST tmp13_AST = null;
			tmp13_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp13_AST);
			match(PLUSEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case MODEQUAL:
		{
			AST tmp14_AST = null;
			tmp14_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp14_AST);
			match(MODEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case SHIFTLEFTEQUAL:
		{
			AST tmp15_AST = null;
			tmp15_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp15_AST);
			match(SHIFTLEFTEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case SHIFTRIGHTEQUAL:
		{
			AST tmp16_AST = null;
			tmp16_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp16_AST);
			match(SHIFTRIGHTEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case BITWISEANDEQUAL:
		{
			AST tmp17_AST = null;
			tmp17_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp17_AST);
			match(BITWISEANDEQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case BITWISEXOREQUAL:
		{
			AST tmp18_AST = null;
			tmp18_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp18_AST);
			match(BITWISEXOREQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		case BITWISEOREQUAL:
		{
			AST tmp19_AST = null;
			tmp19_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp19_AST);
			match(BITWISEOREQUAL);
			assign_op_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = assign_op_AST;
	}
	
/**
  *  Conditional expressions of the form
  *  (logical_expr)?expr:expr
  */
	public final void conditional_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST conditional_expression_AST = null;
		AST log_or_expr_AST = null;
		Token  ques = null;
		AST ques_AST = null;
		AST expr_AST = null;
		Token  colon = null;
		AST colon_AST = null;
		AST cond_expr_AST = null;
		
		logical_or_expression();
		log_or_expr_AST = (AST)returnAST;
		{
		switch ( LA(1)) {
		case QUESTIONMARK:
		{
			ques = LT(1);
			ques_AST = astFactory.create(ques);
			match(QUESTIONMARK);
			expression();
			expr_AST = (AST)returnAST;
			colon = LT(1);
			colon_AST = astFactory.create(colon);
			match(COLON);
			conditional_expression();
			cond_expr_AST = (AST)returnAST;
			break;
		}
		case ETX:
		case COMMA:
		case ASSIGNEQUAL:
		case TIMESEQUAL:
		case DIVIDEEQUAL:
		case MINUSEQUAL:
		case PLUSEQUAL:
		case MODEQUAL:
		case SHIFTLEFTEQUAL:
		case SHIFTRIGHTEQUAL:
		case BITWISEANDEQUAL:
		case BITWISEXOREQUAL:
		case BITWISEOREQUAL:
		case RPAREN:
		case COLON:
		case RSQUARE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			conditional_expression_AST = (AST)currentAST.root;
			
			if (ques != null)
			conditional_expression_AST = (AST)astFactory.make( (new ASTArray(4)).add(astFactory.create(COND_EXPR,"ConditionalExpression")).add(log_or_expr_AST).add(expr_AST).add(cond_expr_AST));
			else
			conditional_expression_AST = log_or_expr_AST;
			
			currentAST.root = conditional_expression_AST;
			currentAST.child = conditional_expression_AST!=null &&conditional_expression_AST.getFirstChild()!=null ?
				conditional_expression_AST.getFirstChild() : conditional_expression_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = conditional_expression_AST;
	}
	
	public final void remainder_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST remainder_expression_AST = null;
		
		{
		boolean synPredMatched15 = false;
		if (((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2))))) {
			int _m15 = mark();
			synPredMatched15 = true;
			inputState.guessing++;
			try {
				{
				conditional_expression();
				{
				switch ( LA(1)) {
				case COMMA:
				{
					match(COMMA);
					break;
				}
				case SEMICOLON:
				{
					match(SEMICOLON);
					break;
				}
				case RPAREN:
				{
					match(RPAREN);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
			}
			catch (RecognitionException pe) {
				synPredMatched15 = false;
			}
			rewind(_m15);
inputState.guessing--;
		}
		if ( synPredMatched15 ) {
			if ( inputState.guessing==0 ) {
				assign_stmt_RHS_found += 1;
			}
			assignment_expression();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				
				if (assign_stmt_RHS_found > 0)
				assign_stmt_RHS_found -= 1;
				else
				{
				System.out.println(LT(1).getLine() + 
				"warning Error in assign_stmt_RHS_found = " +
				assign_stmt_RHS_found + "\n");
				System.out.println("Press return to continue\n");
				}
				
			}
		}
		else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2)))) {
			assignment_expression();
			astFactory.addASTChild(currentAST, returnAST);
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		remainder_expression_AST = (AST)currentAST.root;
		returnAST = remainder_expression_AST;
	}
	
	public final void logical_or_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST logical_or_expression_AST = null;
		
		logical_and_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop20:
		do {
			if ((LA(1)==OR)) {
				AST tmp20_AST = null;
				tmp20_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp20_AST);
				match(OR);
				logical_and_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop20;
			}
			
		} while (true);
		}
		logical_or_expression_AST = (AST)currentAST.root;
		returnAST = logical_or_expression_AST;
	}
	
	public final void logical_and_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST logical_and_expression_AST = null;
		
		inclusive_or_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop23:
		do {
			if ((LA(1)==AND)) {
				AST tmp21_AST = null;
				tmp21_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp21_AST);
				match(AND);
				inclusive_or_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop23;
			}
			
		} while (true);
		}
		logical_and_expression_AST = (AST)currentAST.root;
		returnAST = logical_and_expression_AST;
	}
	
	public final void inclusive_or_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST inclusive_or_expression_AST = null;
		
		exclusive_or_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop26:
		do {
			if ((LA(1)==BITWISEOR)) {
				AST tmp22_AST = null;
				tmp22_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp22_AST);
				match(BITWISEOR);
				exclusive_or_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop26;
			}
			
		} while (true);
		}
		inclusive_or_expression_AST = (AST)currentAST.root;
		returnAST = inclusive_or_expression_AST;
	}
	
	public final void exclusive_or_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST exclusive_or_expression_AST = null;
		
		and_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop29:
		do {
			if ((LA(1)==BITWISEXOR)) {
				AST tmp23_AST = null;
				tmp23_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp23_AST);
				match(BITWISEXOR);
				and_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop29;
			}
			
		} while (true);
		}
		exclusive_or_expression_AST = (AST)currentAST.root;
		returnAST = exclusive_or_expression_AST;
	}
	
	public final void and_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST and_expression_AST = null;
		
		equality_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop32:
		do {
			if ((LA(1)==AMPERSAND)) {
				AST tmp24_AST = null;
				tmp24_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp24_AST);
				match(AMPERSAND);
				equality_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop32;
			}
			
		} while (true);
		}
		and_expression_AST = (AST)currentAST.root;
		returnAST = and_expression_AST;
	}
	
	public final void equality_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST equality_expression_AST = null;
		
		relational_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop36:
		do {
			if ((LA(1)==NOTEQUAL||LA(1)==EQUAL)) {
				{
				switch ( LA(1)) {
				case NOTEQUAL:
				{
					AST tmp25_AST = null;
					tmp25_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp25_AST);
					match(NOTEQUAL);
					break;
				}
				case EQUAL:
				{
					AST tmp26_AST = null;
					tmp26_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp26_AST);
					match(EQUAL);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				relational_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop36;
			}
			
		} while (true);
		}
		equality_expression_AST = (AST)currentAST.root;
		returnAST = equality_expression_AST;
	}
	
	public final void relational_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST relational_expression_AST = null;
		
		shift_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop40:
		do {
			if (((LA(1) >= LESSTHAN && LA(1) <= GREATERTHANOREQUALTO))) {
				{
				switch ( LA(1)) {
				case LESSTHAN:
				{
					AST tmp27_AST = null;
					tmp27_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp27_AST);
					match(LESSTHAN);
					break;
				}
				case GREATERTHAN:
				{
					AST tmp28_AST = null;
					tmp28_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp28_AST);
					match(GREATERTHAN);
					break;
				}
				case LESSTHANOREQUALTO:
				{
					AST tmp29_AST = null;
					tmp29_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp29_AST);
					match(LESSTHANOREQUALTO);
					break;
				}
				case GREATERTHANOREQUALTO:
				{
					AST tmp30_AST = null;
					tmp30_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp30_AST);
					match(GREATERTHANOREQUALTO);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				shift_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop40;
			}
			
		} while (true);
		}
		relational_expression_AST = (AST)currentAST.root;
		returnAST = relational_expression_AST;
	}
	
	public final void shift_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST shift_expression_AST = null;
		
		additive_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop44:
		do {
			if ((LA(1)==SHIFTLEFT||LA(1)==SHIFTRIGHT)) {
				{
				switch ( LA(1)) {
				case SHIFTLEFT:
				{
					AST tmp31_AST = null;
					tmp31_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp31_AST);
					match(SHIFTLEFT);
					break;
				}
				case SHIFTRIGHT:
				{
					AST tmp32_AST = null;
					tmp32_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp32_AST);
					match(SHIFTRIGHT);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				additive_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop44;
			}
			
		} while (true);
		}
		shift_expression_AST = (AST)currentAST.root;
		returnAST = shift_expression_AST;
	}
	
	public final void additive_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST additive_expression_AST = null;
		
		multiplicative_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop48:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					AST tmp33_AST = null;
					tmp33_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp33_AST);
					match(PLUS);
					break;
				}
				case MINUS:
				{
					AST tmp34_AST = null;
					tmp34_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp34_AST);
					match(MINUS);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				multiplicative_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop48;
			}
			
		} while (true);
		}
		additive_expression_AST = (AST)currentAST.root;
		returnAST = additive_expression_AST;
	}
	
	public final void multiplicative_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST multiplicative_expression_AST = null;
		
		unary_expression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop52:
		do {
			if (((LA(1) >= STAR && LA(1) <= MOD))) {
				{
				switch ( LA(1)) {
				case STAR:
				{
					AST tmp35_AST = null;
					tmp35_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp35_AST);
					match(STAR);
					break;
				}
				case DIVIDE:
				{
					AST tmp36_AST = null;
					tmp36_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp36_AST);
					match(DIVIDE);
					break;
				}
				case MOD:
				{
					AST tmp37_AST = null;
					tmp37_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp37_AST);
					match(MOD);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				unary_expression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop52;
			}
			
		} while (true);
		}
		multiplicative_expression_AST = (AST)currentAST.root;
		returnAST = multiplicative_expression_AST;
	}
	
	public final void unary_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST unary_expression_AST = null;
		
		switch ( LA(1)) {
		case PLUS:
		{
			AST tmp38_AST = null;
			tmp38_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp38_AST);
			match(PLUS);
			unary_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_AST = (AST)currentAST.root;
			break;
		}
		case MINUS:
		{
			AST tmp39_AST = null;
			tmp39_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp39_AST);
			match(MINUS);
			unary_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_AST = (AST)currentAST.root;
			break;
		}
		case PLUSPLUS:
		{
			AST tmp40_AST = null;
			tmp40_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp40_AST);
			match(PLUSPLUS);
			pm_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_AST = (AST)currentAST.root;
			break;
		}
		case MINUSMINUS:
		{
			AST tmp41_AST = null;
			tmp41_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp41_AST);
			match(MINUSMINUS);
			pm_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_AST = (AST)currentAST.root;
			break;
		}
		case TILDE:
		case NOT:
		case LPAREN:
		case TAB:
		case LITERAL_this:
		case OCTALINT:
		case DECIMALINT:
		case HEXADECIMALINT:
		case CharLiteral:
		case StringLiteral:
		case FLOAT:
		case LITERAL_true:
		case LITERAL_false:
		case IDENT:
		{
			unary_expression_simple();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = unary_expression_AST;
	}
	
	public final void pm_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST pm_expression_AST = null;
		AST post_expr1_AST = null;
		AST post_expr2_AST = null;
		String sTabText;
		
		primary_expression();
		post_expr1_AST = (AST)returnAST;
		astFactory.addASTChild(currentAST, returnAST);
		if ( inputState.guessing==0 ) {
			
			if(bTabPressed)
			{
			if (post_expr1_AST.getFirstChild() != null)
			sTabText = post_expr1_AST.getFirstChild().getNextSibling().getText();
			else 
			sTabText = post_expr1_AST.getText();
			
			throw new TabException(post_expr1_AST, sTabText);
			}
			
		}
		{
		_loop60:
		do {
			if ((LA(1)==DOTMBR||LA(1)==POINTERTOMBR)) {
				{
				switch ( LA(1)) {
				case DOTMBR:
				{
					AST tmp42_AST = null;
					tmp42_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp42_AST);
					match(DOTMBR);
					break;
				}
				case POINTERTOMBR:
				{
					AST tmp43_AST = null;
					tmp43_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp43_AST);
					match(POINTERTOMBR);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				primary_expression();
				post_expr2_AST = (AST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					
					if (bTabPressed)
					{
					if (post_expr1_AST.getFirstChild() != null)
					sTabText = post_expr1_AST.getFirstChild().getNextSibling().getText();
					else 
					sTabText = post_expr1_AST.getText();
					
					throw new TabException(post_expr1_AST, sTabText);
					}
					
				}
			}
			else {
				break _loop60;
			}
			
		} while (true);
		}
		pm_expression_AST = (AST)currentAST.root;
		returnAST = pm_expression_AST;
	}
	
	public final void unary_expression_simple() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST unary_expression_simple_AST = null;
		
		switch ( LA(1)) {
		case TILDE:
		{
			AST tmp44_AST = null;
			tmp44_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp44_AST);
			match(TILDE);
			unary_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_simple_AST = (AST)currentAST.root;
			break;
		}
		case NOT:
		{
			AST tmp45_AST = null;
			tmp45_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp45_AST);
			match(NOT);
			unary_expression();
			astFactory.addASTChild(currentAST, returnAST);
			unary_expression_simple_AST = (AST)currentAST.root;
			break;
		}
		default:
			if ((LA(1)==LPAREN) && ((LA(2) >= LITERAL_boolean && LA(2) <= LITERAL_double))) {
				cast_expression();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expression_simple_AST = (AST)currentAST.root;
			}
			else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2)))) {
				pm_expression();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expression_simple_AST = (AST)currentAST.root;
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = unary_expression_simple_AST;
	}
	
	public final void cast_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST cast_expression_AST = null;
		AST type_AST = null;
		AST expr_AST = null;
		
		AST tmp46_AST = null;
		tmp46_AST = astFactory.create(LT(1));
		match(LPAREN);
		primitiveType();
		type_AST = (AST)returnAST;
		AST tmp47_AST = null;
		tmp47_AST = astFactory.create(LT(1));
		match(RPAREN);
		unary_expression();
		expr_AST = (AST)returnAST;
		if ( inputState.guessing==0 ) {
			cast_expression_AST = (AST)currentAST.root;
			
			cast_expression_AST = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(CAST,"Cast")).add(type_AST).add(expr_AST));
			
			currentAST.root = cast_expression_AST;
			currentAST.child = cast_expression_AST!=null &&cast_expression_AST.getFirstChild()!=null ?
				cast_expression_AST.getFirstChild() : cast_expression_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = cast_expression_AST;
	}
	
	public final void primitiveType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST primitiveType_AST = null;
		
		switch ( LA(1)) {
		case LITERAL_boolean:
		{
			AST tmp48_AST = null;
			tmp48_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp48_AST);
			match(LITERAL_boolean);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_char:
		{
			AST tmp49_AST = null;
			tmp49_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp49_AST);
			match(LITERAL_char);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_byte:
		{
			AST tmp50_AST = null;
			tmp50_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp50_AST);
			match(LITERAL_byte);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_short:
		{
			AST tmp51_AST = null;
			tmp51_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp51_AST);
			match(LITERAL_short);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_int:
		{
			AST tmp52_AST = null;
			tmp52_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp52_AST);
			match(LITERAL_int);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_long:
		{
			AST tmp53_AST = null;
			tmp53_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp53_AST);
			match(LITERAL_long);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_float:
		{
			AST tmp54_AST = null;
			tmp54_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp54_AST);
			match(LITERAL_float);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_double:
		{
			AST tmp55_AST = null;
			tmp55_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp55_AST);
			match(LITERAL_double);
			primitiveType_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = primitiveType_AST;
	}
	
/**
  *	The TAB over here is not part of the C++ grammar.
  *	This enables auto-completion by allowing the user
  *	to press TAB whenever auto-completion is required
  */
	public final void primary_expression() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST primary_expression_AST = null;
		
		switch ( LA(1)) {
		case TAB:
		case IDENT:
		{
			{
			switch ( LA(1)) {
			case TAB:
			{
				AST tmp56_AST = null;
				tmp56_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp56_AST);
				match(TAB);
				if ( inputState.guessing==0 ) {
					bTabPressed = true;
				}
				break;
			}
			case IDENT:
			{
				variable();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			primary_expression_AST = (AST)currentAST.root;
			break;
		}
		case OCTALINT:
		case DECIMALINT:
		case HEXADECIMALINT:
		case CharLiteral:
		case StringLiteral:
		case FLOAT:
		case LITERAL_true:
		case LITERAL_false:
		{
			constant();
			astFactory.addASTChild(currentAST, returnAST);
			primary_expression_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_this:
		{
			AST tmp57_AST = null;
			tmp57_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp57_AST);
			match(LITERAL_this);
			primary_expression_AST = (AST)currentAST.root;
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			primary_expression_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = primary_expression_AST;
	}
	
/**
  *  TabException is raised everytime the TAB is pressed.
  *  The parser thus bails out immediately and returns the
  *  parse tree constructed so far.
  */
	public final void variable() throws RecognitionException, TokenStreamException, TabException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variable_AST = null;
		AST prim_expr_AST = null;
		AST expr1_AST = null;
		AST expr2_AST = null;
		Token  tb = null;
		AST tb_AST = null;
		AST id_expr1_AST = null;
		AST id_expr2_AST = null;
		
		AST astPostExpr = null, astDotExpr = null;
		
		
		{
		id_expression();
		prim_expr_AST = (AST)returnAST;
		if ( inputState.guessing==0 ) {
			
			astPostExpr = prim_expr_AST;
			
		}
		{
		_loop66:
		do {
			switch ( LA(1)) {
			case LSQUARE:
			{
				AST tmp60_AST = null;
				tmp60_AST = astFactory.create(LT(1));
				match(LSQUARE);
				expression();
				expr1_AST = (AST)returnAST;
				AST tmp61_AST = null;
				tmp61_AST = astFactory.create(LT(1));
				match(RSQUARE);
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(ARRAY_REF,"ArrayReference")).add(astPostExpr).add(expr1_AST));
				}
				break;
			}
			case LPAREN:
			{
				AST tmp62_AST = null;
				tmp62_AST = astFactory.create(LT(1));
				match(LPAREN);
				{
				switch ( LA(1)) {
				case PLUS:
				case MINUS:
				case PLUSPLUS:
				case MINUSMINUS:
				case TILDE:
				case NOT:
				case LPAREN:
				case TAB:
				case LITERAL_this:
				case OCTALINT:
				case DECIMALINT:
				case HEXADECIMALINT:
				case CharLiteral:
				case StringLiteral:
				case FLOAT:
				case LITERAL_true:
				case LITERAL_false:
				case IDENT:
				{
					expressionList();
					expr2_AST = (AST)returnAST;
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp63_AST = null;
				tmp63_AST = astFactory.create(LT(1));
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(FUNC_CALL,"FuncCall")).add(astPostExpr).add(expr2_AST));
				}
				break;
			}
			case DOT:
			{
				AST tmp64_AST = null;
				tmp64_AST = astFactory.create(LT(1));
				match(DOT);
				{
				switch ( LA(1)) {
				case TAB:
				{
					tb = LT(1);
					tb_AST = astFactory.create(tb);
					match(TAB);
					if ( inputState.guessing==0 ) {
						
						bTabPressed = true;
						astDotExpr = tb_AST; 
						
					}
					break;
				}
				case IDENT:
				{
					id_expression();
					id_expr1_AST = (AST)returnAST;
					if ( inputState.guessing==0 ) {
						astDotExpr = id_expr1_AST;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(3)).add(tmp64_AST).add(astPostExpr).add(astDotExpr));
				}
				break;
			}
			case POINTERTO:
			{
				AST tmp65_AST = null;
				tmp65_AST = astFactory.create(LT(1));
				match(POINTERTO);
				id_expression();
				id_expr2_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(3)).add(tmp65_AST).add(astPostExpr).add(id_expr2_AST));
				}
				break;
			}
			case PLUSPLUS:
			{
				AST tmp66_AST = null;
				tmp66_AST = astFactory.create(LT(1));
				match(PLUSPLUS);
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(2)).add(tmp66_AST).add(astPostExpr));
				}
				break;
			}
			case MINUSMINUS:
			{
				AST tmp67_AST = null;
				tmp67_AST = astFactory.create(LT(1));
				match(MINUSMINUS);
				if ( inputState.guessing==0 ) {
					astPostExpr = (AST)astFactory.make( (new ASTArray(2)).add(tmp67_AST).add(astPostExpr));
				}
				break;
			}
			default:
			{
				break _loop66;
			}
			}
		} while (true);
		}
		}
		if ( inputState.guessing==0 ) {
			variable_AST = (AST)currentAST.root;
			
			variable_AST = astPostExpr; 
			
			currentAST.root = variable_AST;
			currentAST.child = variable_AST!=null &&variable_AST.getFirstChild()!=null ?
				variable_AST.getFirstChild() : variable_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = variable_AST;
	}
	
	public final void id_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST id_expression_AST = null;
		
		AST tmp68_AST = null;
		tmp68_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp68_AST);
		match(IDENT);
		id_expression_AST = (AST)currentAST.root;
		returnAST = id_expression_AST;
	}
	
	public final void constant() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constant_AST = null;
		
		switch ( LA(1)) {
		case OCTALINT:
		{
			AST tmp69_AST = null;
			tmp69_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp69_AST);
			match(OCTALINT);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case DECIMALINT:
		{
			AST tmp70_AST = null;
			tmp70_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp70_AST);
			match(DECIMALINT);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case HEXADECIMALINT:
		{
			AST tmp71_AST = null;
			tmp71_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp71_AST);
			match(HEXADECIMALINT);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case CharLiteral:
		{
			AST tmp72_AST = null;
			tmp72_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp72_AST);
			match(CharLiteral);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case StringLiteral:
		{
			{
			int _cnt71=0;
			_loop71:
			do {
				if ((LA(1)==StringLiteral)) {
					AST tmp73_AST = null;
					tmp73_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp73_AST);
					match(StringLiteral);
				}
				else {
					if ( _cnt71>=1 ) { break _loop71; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt71++;
			} while (true);
			}
			constant_AST = (AST)currentAST.root;
			break;
		}
		case FLOAT:
		{
			AST tmp74_AST = null;
			tmp74_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp74_AST);
			match(FLOAT);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_true:
		{
			AST tmp75_AST = null;
			tmp75_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp75_AST);
			match(LITERAL_true);
			constant_AST = (AST)currentAST.root;
			break;
		}
		case LITERAL_false:
		{
			AST tmp76_AST = null;
			tmp76_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp76_AST);
			match(LITERAL_false);
			constant_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = constant_AST;
	}
	
	public final void tid_expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST tid_expression_AST = null;
		
		AST tmp77_AST = null;
		tmp77_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp77_AST);
		match(TAB_IDENT);
		tid_expression_AST = (AST)currentAST.root;
		returnAST = tid_expression_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ARG_LIST",
		"ARRAY_REF",
		"CAST",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"ETX",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"LPAREN",
		"DOTMBR",
		"POINTERTOMBR",
		"LSQUARE",
		"RSQUARE",
		"DOT",
		"TAB",
		"POINTERTO",
		"\"this\"",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"\"true\"",
		"\"false\"",
		"IDENT",
		"TAB_IDENT",
		"\"operator\"",
		"LCURLY",
		"RCURLY",
		"ELLIPSIS",
		"SCOPE",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	}
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { -9078725784662704128L, 2046L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { -8389632L, 2047L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { -9079256848778919936L, 2046L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { -143552238130824192L, 2047L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	
	}
