// $ANTLR 2.7.6 (2005-12-22): "cpp.g" -> "CppTreeParser.java"$

// This file is part of the program FRYSK.
//
// Copyright 2005, Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    import frysk.value.*;
    import java.util.*;
    import lib.dw.BaseTypes;
    import inua.eio.ByteOrder;

/* import antlr.TreeParser; */
/* import antlr.Token; */
import antlr.collections.AST;
import antlr.RecognitionException;
/* import antlr.ANTLRException; */
import antlr.NoViableAltException;
/* import antlr.MismatchedTokenException; */
/* import antlr.SemanticException; */
/* import antlr.collections.impl.BitSet; */
/* import antlr.ASTPair; */
/* import antlr.collections.impl.ASTArray; */


public class CppTreeParser extends antlr.TreeParser       implements CppTreeParserTokenTypes
 {

    IntegerType intType;
    ShortType shortType;
    FloatType floatType;
    private CppSymTab cppSymTabRef;
    public CppTreeParser(int intSize, int shortSize, CppSymTab symTab) {
        this();
	cppSymTabRef = symTab; 
        intType = new IntegerType(intSize, ByteOrder.LITTLE_ENDIAN);
        floatType = new FloatType(intSize, ByteOrder.LITTLE_ENDIAN);
        shortType = new ShortType(shortSize, ByteOrder.LITTLE_ENDIAN);
    }
public CppTreeParser() {
	tokenNames = _tokenNames;
}

	public final void primitiveType(AST _t) throws RecognitionException {
		
		AST primitiveType_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_boolean:
			{
				AST tmp78_AST_in = (AST)_t;
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_char:
			{
				AST tmp79_AST_in = (AST)_t;
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_byte:
			{
				AST tmp80_AST_in = (AST)_t;
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_short:
			{
				AST tmp81_AST_in = (AST)_t;
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_int:
			{
				AST tmp82_AST_in = (AST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_long:
			{
				AST tmp83_AST_in = (AST)_t;
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_float:
			{
				AST tmp84_AST_in = (AST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_double:
			{
				AST tmp85_AST_in = (AST)_t;
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final Variable  expr(AST _t) throws RecognitionException, InvalidOperatorException,OperationNotDefinedException {
		Variable returnVar=null;
		
		AST expr_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST o = null;
		AST i = null;
		AST h = null;
		AST f = null;
		AST pt = null;
		AST ident = null;
		AST tident = null;
		Variable v1, v2, log_expr;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PLUS:
			{
				AST __t215 = _t;
				AST tmp86_AST_in = (AST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t215;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						returnVar = v1.getType().add(v1, v2);
				}
				break;
			}
			case STAR:
			{
				AST __t221 = _t;
				AST tmp87_AST_in = (AST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t221;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						returnVar = v1.getType().multiply(v1, v2);
				}
				break;
			}
			case DIVIDE:
			{
				AST __t222 = _t;
				AST tmp88_AST_in = (AST)_t;
				match(_t,DIVIDE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t222;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().divide(v1, v2);
				}
				break;
			}
			case MOD:
			{
				AST __t223 = _t;
				AST tmp89_AST_in = (AST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t223;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						returnVar = v1.getType().mod(v1, v2);
				}
				break;
			}
			case SHIFTLEFT:
			{
				AST __t224 = _t;
				AST tmp90_AST_in = (AST)_t;
				match(_t,SHIFTLEFT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t224;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
					if((v1.getType().getTypeId() < BaseTypes.baseTypeChar && v1.getType().getTypeId() > BaseTypes.baseTypeLong) ||
					(v2.getType().getTypeId() < BaseTypes.baseTypeChar && v2.getType().getTypeId() > BaseTypes.baseTypeLong)) {
					
					throw new OperationNotDefinedException("binary operator << not defined for types " + 
					v1.getType().getName() + " and " + v2.getType().getName());
					}
					
					returnVar = v1.getType().shiftLeft(v1, v2);
				}
				break;
			}
			case SHIFTRIGHT:
			{
				AST __t225 = _t;
				AST tmp91_AST_in = (AST)_t;
				match(_t,SHIFTRIGHT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t225;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
					if((v1.getType().getTypeId() < BaseTypes.baseTypeChar && v1.getType().getTypeId() > BaseTypes.baseTypeLong) ||
					(v2.getType().getTypeId() < BaseTypes.baseTypeChar && v2.getType().getTypeId() > BaseTypes.baseTypeLong)) {
					
					throw new OperationNotDefinedException("binary operator >> not defined for types " + 
					v1.getType().getName() + " and " + v2.getType().getName());
					}
					
					returnVar = v1.getType().shiftRight(v1, v2);
				}
				break;
			}
			case LESSTHAN:
			{
				AST __t226 = _t;
				AST tmp92_AST_in = (AST)_t;
				match(_t,LESSTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t226;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().lessThan(v1, v2);
				}
				break;
			}
			case GREATERTHAN:
			{
				AST __t227 = _t;
				AST tmp93_AST_in = (AST)_t;
				match(_t,GREATERTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t227;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().greaterThan(v1, v2);
				}
				break;
			}
			case LESSTHANOREQUALTO:
			{
				AST __t228 = _t;
				AST tmp94_AST_in = (AST)_t;
				match(_t,LESSTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t228;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().lessThanOrEqualTo(v1, v2);
				}
				break;
			}
			case GREATERTHANOREQUALTO:
			{
				AST __t229 = _t;
				AST tmp95_AST_in = (AST)_t;
				match(_t,GREATERTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t229;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().greaterThanOrEqualTo(v1, v2);
				}
				break;
			}
			case NOTEQUAL:
			{
				AST __t230 = _t;
				AST tmp96_AST_in = (AST)_t;
				match(_t,NOTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t230;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().notEqual(v1, v2);
				}
				break;
			}
			case EQUAL:
			{
				AST __t231 = _t;
				AST tmp97_AST_in = (AST)_t;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t231;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().equal(v1, v2);
				}
				break;
			}
			case AMPERSAND:
			{
				AST __t232 = _t;
				AST tmp98_AST_in = (AST)_t;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t232;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().bitWiseAnd(v1, v2);
				}
				break;
			}
			case BITWISEXOR:
			{
				AST __t233 = _t;
				AST tmp99_AST_in = (AST)_t;
				match(_t,BITWISEXOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t233;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().bitWiseXor(v1, v2);
				}
				break;
			}
			case BITWISEOR:
			{
				AST __t234 = _t;
				AST tmp100_AST_in = (AST)_t;
				match(_t,BITWISEOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t234;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().bitWiseOr(v1, v2);
				}
				break;
			}
			case AND:
			{
				AST __t235 = _t;
				AST tmp101_AST_in = (AST)_t;
				match(_t,AND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t235;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().logicalAnd(v1, v2);
				}
				break;
			}
			case OR:
			{
				AST __t236 = _t;
				AST tmp102_AST_in = (AST)_t;
				match(_t,OR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t236;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1.getType().logicalOr(v1, v2);
				}
				break;
			}
			case COND_EXPR:
			{
				AST __t237 = _t;
				AST tmp103_AST_in = (AST)_t;
				match(_t,COND_EXPR);
				_t = _t.getFirstChild();
				log_expr=expr(_t);
				_t = _retTree;
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t237;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((log_expr.getType().getLogicalValue(log_expr)) ? v1 : v2);  
					
				}
				break;
			}
			case OCTALINT:
			{
				o = (AST)_t;
				match(_t,OCTALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = o.getText().charAt(o.getText().length() - 1);
						    int l = o.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar = IntegerType.newIntegerVariable (
					intType, Integer.parseInt(o.getText().substring(1, l), 8));
					
				}
				break;
			}
			case DECIMALINT:
			{
				i = (AST)_t;
				match(_t,DECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = i.getText().charAt(i.getText().length() - 1);
						    int l = i.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar = IntegerType.newIntegerVariable (
					intType, Integer.parseInt(i.getText().substring(0, l)));
					
				}
				break;
			}
			case HEXADECIMALINT:
			{
				h = (AST)_t;
				match(_t,HEXADECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = h.getText().charAt(h.getText().length() - 1);
						    int l = h.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar = IntegerType.newIntegerVariable (
					intType, Integer.parseInt(h.getText().substring(2, l), 16));
					
				}
				break;
			}
			case FLOAT:
			{
				f = (AST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = f.getText().charAt(f.getText().length() - 1);
						    int l = f.getText().length();
						    if (c == 'f' || c == 'F' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar = FloatType.newFloatVariable (
					floatType, Float.parseFloat(f.getText().substring(0, l)));
					
				}
				break;
			}
			case ASSIGNEQUAL:
			{
				AST __t238 = _t;
				AST tmp104_AST_in = (AST)_t;
				match(_t,ASSIGNEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t238;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().assign(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case TIMESEQUAL:
			{
				AST __t239 = _t;
				AST tmp105_AST_in = (AST)_t;
				match(_t,TIMESEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t239;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().timesEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case DIVIDEEQUAL:
			{
				AST __t240 = _t;
				AST tmp106_AST_in = (AST)_t;
				match(_t,DIVIDEEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t240;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().divideEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case MINUSEQUAL:
			{
				AST __t241 = _t;
				AST tmp107_AST_in = (AST)_t;
				match(_t,MINUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t241;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().minusEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case PLUSEQUAL:
			{
				AST __t242 = _t;
				AST tmp108_AST_in = (AST)_t;
				match(_t,PLUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t242;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().plusEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case MODEQUAL:
			{
				AST __t243 = _t;
				AST tmp109_AST_in = (AST)_t;
				match(_t,MODEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t243;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().modEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case SHIFTLEFTEQUAL:
			{
				AST __t244 = _t;
				AST tmp110_AST_in = (AST)_t;
				match(_t,SHIFTLEFTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t244;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().shiftLeftEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case SHIFTRIGHTEQUAL:
			{
				AST __t245 = _t;
				AST tmp111_AST_in = (AST)_t;
				match(_t,SHIFTRIGHTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t245;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().shiftRightEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case BITWISEANDEQUAL:
			{
				AST __t246 = _t;
				AST tmp112_AST_in = (AST)_t;
				match(_t,BITWISEANDEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t246;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().bitWiseAndEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case BITWISEXOREQUAL:
			{
				AST __t247 = _t;
				AST tmp113_AST_in = (AST)_t;
				match(_t,BITWISEXOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t247;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().bitWiseXorEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case BITWISEOREQUAL:
			{
				AST __t248 = _t;
				AST tmp114_AST_in = (AST)_t;
				match(_t,BITWISEOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t248;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if(v1.getType().getTypeId() != v2.getType().getTypeId())
					v1 = v2.getType().newVariable(v2.getType(), v1);
					v1.getType().bitWiseOrEqual(v1, v2);
					returnVar = v1;
					cppSymTabRef.put(v1.getText(), v1);
					
				}
				break;
			}
			case CAST:
			{
				AST __t249 = _t;
				AST tmp115_AST_in = (AST)_t;
				match(_t,CAST);
				_t = _t.getFirstChild();
				pt = _t==ASTNULL ? null : (AST)_t;
				primitiveType(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t249;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    if(pt.getText().compareTo("short") == 0) {
						      returnVar = shortType.newShortVariable(shortType, "0", (short)0);
					returnVar.getType().assign(returnVar, v2);
						      }
						    else if(pt.getText().compareTo("float") == 0) {
						      returnVar = floatType.newFloatVariable(floatType, "0", (float)0);
					returnVar.getType().assign(returnVar, v2);
						      }
						    else returnVar = v2;
					
				}
				break;
			}
			case EXPR_LIST:
			{
				AST __t250 = _t;
				AST tmp116_AST_in = (AST)_t;
				match(_t,EXPR_LIST);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t250;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1;
				}
				break;
			}
			case FUNC_CALL:
			{
				AST __t251 = _t;
				AST tmp117_AST_in = (AST)_t;
				match(_t,FUNC_CALL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t251;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					returnVar = v1;
				}
				break;
			}
			case IDENT:
			{
				ident = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if((returnVar = ((Variable)cppSymTabRef.get(ident.getText()))) == null
							&& cppSymTabRef.putUndefined()) {
					returnVar = IntegerType.newIntegerVariable(intType, ident.getText(), 0);
					cppSymTabRef.put(ident.getText(), returnVar);
					}
					
				}
				break;
			}
			case TAB_IDENT:
			{
				tident = (AST)_t;
				match(_t,TAB_IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					if((returnVar = ((Variable)cppSymTabRef.get(tident.getText()))) == null
							&& cppSymTabRef.putUndefined()) {
					returnVar = IntegerType.newIntegerVariable(intType, tident.getText(), 0);
					cppSymTabRef.put(tident.getText(), returnVar);
					}
					
				}
				break;
			}
			default:
				boolean synPredMatched218 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==MINUS))) {
					AST __t218 = _t;
					synPredMatched218 = true;
					inputState.guessing++;
					try {
						{
						AST __t217 = _t;
						AST tmp118_AST_in = (AST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expr(_t);
						_t = _retTree;
						expr(_t);
						_t = _retTree;
						_t = __t217;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched218 = false;
					}
					_t = __t218;
inputState.guessing--;
				}
				if ( synPredMatched218 ) {
					AST __t219 = _t;
					AST tmp119_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					v2=expr(_t);
					_t = _retTree;
					_t = __t219;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						returnVar = v1.getType().subtract(v1, v2);
					}
				}
				else if ((_t.getType()==MINUS)) {
					AST __t220 = _t;
					AST tmp120_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					_t = __t220;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						returnVar = IntegerType.newIntegerVariable(intType, "0", 0);
						returnVar = returnVar.getType().subtract(returnVar, v1);
					}
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return returnVar;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ARG_LIST",
		"ARRAY_REF",
		"CAST",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"ETX",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"LPAREN",
		"DOTMBR",
		"POINTERTOMBR",
		"LSQUARE",
		"RSQUARE",
		"DOT",
		"TAB",
		"POINTERTO",
		"\"this\"",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"\"true\"",
		"\"false\"",
		"IDENT",
		"TAB_IDENT",
		"\"operator\"",
		"LCURLY",
		"RCURLY",
		"ELLIPSIS",
		"SCOPE",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM"
	};
	
	}
	
