package inua.elf;

public class ELF
{
  public static class MAG
  {
    static public final int _0 = 0x7f;
    static public final int _1 = 'E';
    static public final int _2 = 'L';
    static public final int _3 = 'F';
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case _0: return "ELF_MAG_0";
      case _1: return "ELF_MAG_1";
      case _2: return "ELF_MAG_2";
      case _3: return "ELF_MAG_3";
      default: return "ELF_MAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case _0: return "_0";
      case _1: return "_1";
      case _2: return "_2";
      case _3: return "_3";
      default: return "ELF_MAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case _0: return "ELFMAG0";
      case _1: return "ELFMAG1";
      case _2: return "ELFMAG2";
      case _3: return "ELFMAG3";
      default: return "ELF_MAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case _0: return "ELFMAG0";
      case _1: return "ELFMAG1";
      case _2: return "ELFMAG2";
      case _3: return "ELFMAG3";
      default: return def;
      }
    }
  }
  public static class CLASS
  {
    static public final int NONE = 0;
    static public final int _32 = 1;
    static public final int _64 = 2;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case NONE: return "ELF_CLASS_NONE";
      case _32: return "ELF_CLASS_32";
      case _64: return "ELF_CLASS_64";
      default: return "ELF_CLASS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case NONE: return "NONE";
      case _32: return "_32";
      case _64: return "_64";
      default: return "ELF_CLASS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case NONE: return "ELFCLASSNONE";
      case _32: return "ELF32";
      case _64: return "ELF64";
      default: return "ELF_CLASS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case NONE: return "ELFCLASSNONE";
      case _32: return "ELF32";
      case _64: return "ELF64";
      default: return def;
      }
    }
  }
  public static class DATA
  {
    static public final int NONE = 0;
    static public final int _2LSB = 1;
    static public final int _2MSB = 2;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case NONE: return "ELF_DATA_NONE";
      case _2LSB: return "ELF_DATA_2LSB";
      case _2MSB: return "ELF_DATA_2MSB";
      default: return "ELF_DATA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case NONE: return "NONE";
      case _2LSB: return "_2LSB";
      case _2MSB: return "_2MSB";
      default: return "ELF_DATA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case NONE: return "ELFDATANONE";
      case _2LSB: return "2's complement, little endian";
      case _2MSB: return "2's complement, big endian";
      default: return "ELF_DATA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case NONE: return "ELFDATANONE";
      case _2LSB: return "2's complement, little endian";
      case _2MSB: return "2's complement, big endian";
      default: return def;
      }
    }
  }
  public static class OSABI
  {
    static public final int NONE = 0;
    static public final int SYSV = 0;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case NONE: return "ELF_OSABI_NONE";
      default: return "ELF_OSABI_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case NONE: return "NONE";
      default: return "ELF_OSABI_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case NONE: return "UNIX - System V";
      default: return "ELF_OSABI_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case NONE: return "UNIX - System V";
      default: return def;
      }
    }
  }

  static public String toString (long i)
  {
    switch ((int) i) {
    default: return "ELF_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    default: return "ELF_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    default: return "ELF_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    default: return def;
    }
  }
}
