package inua.elf;

public class EM
{
  static public final int NONE = 0;
  static public final int M32 = 1;
  static public final int SPARC = 2;
  static public final int I386 = 3;
  static public final int M68K = 4;
  static public final int M88K = 5;
  static public final int M860 = 7;
  static public final int MIPS = 8;
  static public final int S370 = 9;
  static public final int PPC = 20;
  static public final int PPC64 = 21;
  static public final int S390 = 22;
  static public final int X86_64 = 63;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NONE: return "EM_NONE";
    case M32: return "EM_M32";
    case SPARC: return "EM_SPARC";
    case I386: return "EM_I386";
    case M68K: return "EM_M68K";
    case M88K: return "EM_M88K";
    case M860: return "EM_M860";
    case MIPS: return "EM_MIPS";
    case S370: return "EM_S370";
    case PPC: return "EM_PPC";
    case PPC64: return "EM_PPC64";
    case S390: return "EM_S390";
    case X86_64: return "EM_X86_64";
    default: return "EM_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case M32: return "M32";
    case SPARC: return "SPARC";
    case I386: return "I386";
    case M68K: return "M68K";
    case M88K: return "M88K";
    case M860: return "M860";
    case MIPS: return "MIPS";
    case S370: return "S370";
    case PPC: return "PPC";
    case PPC64: return "PPC64";
    case S390: return "S390";
    case X86_64: return "X86_64";
    default: return "EM_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case M32: return "M32";
    case SPARC: return "SPARC";
    case I386: return "Intel 80386";
    case M68K: return "M68K";
    case M88K: return "M88K";
    case M860: return "M860";
    case MIPS: return "MIPS";
    case S370: return "S370";
    case PPC: return "PowerPC";
    case PPC64: return "PPC64";
    case S390: return "S390";
    case X86_64: return "X86 64";
    default: return "EM_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case M32: return "M32";
    case SPARC: return "SPARC";
    case I386: return "Intel 80386";
    case M68K: return "M68K";
    case M88K: return "M88K";
    case M860: return "M860";
    case MIPS: return "MIPS";
    case S370: return "S370";
    case PPC: return "PowerPC";
    case PPC64: return "PPC64";
    case S390: return "S390";
    case X86_64: return "X86 64";
    default: return def;
    }
  }
}
