package inua.elf;

public class ET
{
  static public final int NONE = 0;
  static public final int REL = 1;
  static public final int EXEC = 2;
  static public final int DYN = 3;
  static public final int CORE = 4;
  static public final int LOPROC = 0xff00;
  static public final int HIPROC = 0xffff;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NONE: return "ET_NONE";
    case REL: return "ET_REL";
    case EXEC: return "ET_EXEC";
    case DYN: return "ET_DYN";
    case CORE: return "ET_CORE";
    case LOPROC: return "ET_LOPROC";
    case HIPROC: return "ET_HIPROC";
    default: return "ET_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case REL: return "REL";
    case EXEC: return "EXEC";
    case DYN: return "DYN";
    case CORE: return "CORE";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "ET_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case REL: return "REL";
    case EXEC: return "EXEC (Executable file)";
    case DYN: return "DYN";
    case CORE: return "CORE";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "ET_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NONE: return "NONE";
    case REL: return "REL";
    case EXEC: return "EXEC (Executable file)";
    case DYN: return "DYN";
    case CORE: return "CORE";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return def;
    }
  }
}
