package inua.elf;

public class STV
{
  static public final int DEFAULT = 0;
  static public final int INTERNAL = 1;
  static public final int HIDDEN = 2;
  static public final int PROTECTED = 3;

  static public String toString (long i)
  {
    switch ((int) i) {
    case DEFAULT: return "STV_DEFAULT";
    case INTERNAL: return "STV_INTERNAL";
    case HIDDEN: return "STV_HIDDEN";
    case PROTECTED: return "STV_PROTECTED";
    default: return "STV_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case DEFAULT: return "DEFAULT";
    case INTERNAL: return "INTERNAL";
    case HIDDEN: return "HIDDEN";
    case PROTECTED: return "PROTECTED";
    default: return "STV_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case DEFAULT: return "DEFAULT";
    case INTERNAL: return "INTERNAL";
    case HIDDEN: return "HIDDEN";
    case PROTECTED: return "PROTECTED";
    default: return "STV_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case DEFAULT: return "DEFAULT";
    case INTERNAL: return "INTERNAL";
    case HIDDEN: return "HIDDEN";
    case PROTECTED: return "PROTECTED";
    default: return def;
    }
  }
}
